package com.gx.obe.struct.beans;

import java.math.BigDecimal;

/**
 * @Description: 资产负债表
 * @author chenxw
 */
public class BalanceSheet {
	
	/**
	 * 主键
	 */
	private String id;
	/**
	 * 项目ID
	 */
	private String tenderId;
	/**
	 * 财务ID
	 */
	private String financeId;
	/**
	 * 总资产
	 */
	private BigDecimal balanceTotal;
	/**
	 * 流动资产
	 */
	private BigDecimal balanceCecurrentAssets;
	/**
	 * 存货
	 */
	private BigDecimal inventory;
	/**
	 * 应收账款
	 */
	private BigDecimal receivables;
	/**
	 * 不良资产
	 */
	private BigDecimal badAssets;
	/**
	 * 总负债
	 */
	private BigDecimal balanceTotalliabilities;
	/**
	 * 流动负债
	 */
	private BigDecimal balanceCurrentLiabilities;
	/**
	 * 所有者权益
	 */
	private BigDecimal ownershipInterest;
	/**
	 * 其中：当年非正常增加
	 */
	private BigDecimal abnormalIncrease;
	
	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	public String getTenderId() {
		return tenderId;
	}
	
	public void setTenderId(String tenderId) {
		this.tenderId = tenderId;
	}
	
	public String getFinanceId() {
		return financeId;
	}
	
	public void setFinanceId(String financeId) {
		this.financeId = financeId;
	}
	
	public BigDecimal getBalanceTotal() {
		return balanceTotal;
	}
	
	public void setBalanceTotal(BigDecimal balanceTotal) {
		this.balanceTotal = balanceTotal;
	}
	
	public BigDecimal getBalanceCecurrentAssets() {
		return balanceCecurrentAssets;
	}
	
	public void setBalanceCecurrentAssets(BigDecimal balanceCecurrentAssets) {
		this.balanceCecurrentAssets = balanceCecurrentAssets;
	}
	
	public BigDecimal getInventory() {
		return inventory;
	}
	
	public void setInventory(BigDecimal inventory) {
		this.inventory = inventory;
	}
	
	public BigDecimal getReceivables() {
		return receivables;
	}
	
	public void setReceivables(BigDecimal receivables) {
		this.receivables = receivables;
	}
	
	public BigDecimal getBadAssets() {
		return badAssets;
	}
	
	public void setBadAssets(BigDecimal badAssets) {
		this.badAssets = badAssets;
	}
	
	public BigDecimal getBalanceTotalliabilities() {
		return balanceTotalliabilities;
	}
	
	public void setBalanceTotalliabilities(BigDecimal balanceTotalliabilities) {
		this.balanceTotalliabilities = balanceTotalliabilities;
	}
	
	public BigDecimal getBalanceCurrentLiabilities() {
		return balanceCurrentLiabilities;
	}
	
	public void setBalanceCurrentLiabilities(BigDecimal balanceCurrentLiabilities) {
		this.balanceCurrentLiabilities = balanceCurrentLiabilities;
	}
	
	public BigDecimal getOwnershipInterest() {
		return ownershipInterest;
	}
	
	public void setOwnershipInterest(BigDecimal ownershipInterest) {
		this.ownershipInterest = ownershipInterest;
	}
	
	public BigDecimal getAbnormalIncrease() {
		return abnormalIncrease;
	}
	
	public void setAbnormalIncrease(BigDecimal abnormalIncrease) {
		this.abnormalIncrease = abnormalIncrease;
	}
	
}