package com.gx.obe.struct.beans;

import java.math.BigDecimal;

/**
 * @Description: 财务报表
 * @author chenxw
 */
public class Finance {
	
	/**
	 * 主键
	 */
	private String id;
	/**
	 * 项目ID
	 */
	private String tenderId;
	/**
	 * 模型数据ID
	 */
	private String modelDataId;
	/**
	 * 年度
	 */
	private String annual;
	/**
	 * 注册资本
	 */
//	private BigDecimal registeredCapital;
	/**
	 * 总资产（万元）
	 */
	private BigDecimal total;
	/**
	 * 利润总额（万元）
	 */
	private BigDecimal profitLossProfit;
	/**
	 * 营业收入（万元）
	 */
	private BigDecimal operatingIncome;
	/**
	 * 资产负债率（%）
	 */
	private BigDecimal liabilitiesRate;
	/**
	 * 流动资产（万元）
	 */
	private BigDecimal currentAssets;
	/**
	 * 流动负债（万元）
	 */
	private BigDecimal currentLiabilities;
	/**
	 * 流动比率（%）
	 */
	private BigDecimal currentRate;
	/**
	 * 净利率（%）
	 */
	private BigDecimal profitRatio;
	/**
	 * 主营业务利润率（%）
	 */
	private BigDecimal operatingMargin;
	/**
	 * 净利润（万元）
	 */
	private BigDecimal retainedProfits;
	/**
	 * 企业名称
	 */
	private String companyName;
	/**
	 * 净资产（万元）
	 */
	private BigDecimal netWorth;
	/**
	 * 固定资产（万元）
	 */
//	private BigDecimal fixedAssets;
	/**
	 * 现金流量净额（万元）
	 */
//	private BigDecimal netCashFlow;
	/**
	 * 净资产收益率（%）
	 */
//	private BigDecimal returnOnEquity;
	/**
	 * 总资产报酬率（%）
	 */
//	private BigDecimal returnOnTotalAsset;
	/**
	 * 速动比率（%）
	 */
	private BigDecimal quickRatio;
	/**
	 * 负债合计（万元）
	 */
	private BigDecimal totalliabilities;
	/**
	 * 成本费用总额（万元）
	 */
	private BigDecimal totalcost;
	/**
	 * 速动资产（万元）
	 */
	private BigDecimal quickassets;
	/**
	 * 主营业务利润（万元）
	 */
	private BigDecimal mainIncomeProfits;
	/**
	 * 主营业务收入（万元）
	 */
	private BigDecimal primeOperatingRevenue;
	/**
	 * 资产负债表
	 */
//	private BalanceSheet balanceSheet;
	/**
	 * 损益表
	 */
//	private ProfitlossSheet profitlossSheet;
	/**
	 * 现金流量表
	 */
//	private CashSheet cashSheet;
	
	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	public String getTenderId() {
		return tenderId;
	}
	
	public void setTenderId(String tenderId) {
		this.tenderId = tenderId;
	}
	
	public String getModelDataId() {
		return modelDataId;
	}
	
	public void setModelDataId(String modelDataId) {
		this.modelDataId = modelDataId;
	}
	
	public String getAnnual() {
		return annual;
	}
	
	public void setAnnual(String annual) {
		this.annual = annual;
	}
	
	public BigDecimal getTotal() {
		return total;
	}
	
	public void setTotal(BigDecimal total) {
		this.total = total;
	}
	
	public BigDecimal getOperatingIncome() {
		return operatingIncome;
	}
	
	public void setOperatingIncome(BigDecimal operatingIncome) {
		this.operatingIncome = operatingIncome;
	}
	
	public BigDecimal getLiabilitiesRate() {
		return liabilitiesRate;
	}
	
	public void setLiabilitiesRate(BigDecimal liabilitiesRate) {
		this.liabilitiesRate = liabilitiesRate;
	}
	
	public BigDecimal getCurrentAssets() {
		return currentAssets;
	}
	
	public void setCurrentAssets(BigDecimal currentAssets) {
		this.currentAssets = currentAssets;
	}
	
	public BigDecimal getCurrentLiabilities() {
		return currentLiabilities;
	}
	
	public void setCurrentLiabilities(BigDecimal currentLiabilities) {
		this.currentLiabilities = currentLiabilities;
	}
	
	public BigDecimal getCurrentRate() {
		return currentRate;
	}
	
	public void setCurrentRate(BigDecimal currentRate) {
		this.currentRate = currentRate;
	}
	
	public BigDecimal getOperatingMargin() {
		return operatingMargin;
	}
	
	public void setOperatingMargin(BigDecimal operatingMargin) {
		this.operatingMargin = operatingMargin;
	}
	
	public BigDecimal getRetainedProfits() {
		return retainedProfits;
	}
	
	public void setRetainedProfits(BigDecimal retainedProfits) {
		this.retainedProfits = retainedProfits;
	}
	
	public String getCompanyName() {
		return companyName;
	}
	
	public void setCompanyName(String companyName) {
		this.companyName = companyName;
	}
	
	public BigDecimal getNetWorth() {
		return netWorth;
	}
	
	public void setNetWorth(BigDecimal netWorth) {
		this.netWorth = netWorth;
	}
	
//	public BigDecimal getFixedAssets() {
//		return fixedAssets;
//	}
//	
//	public void setFixedAssets(BigDecimal fixedAssets) {
//		this.fixedAssets = fixedAssets;
//	}
//	
//	public BigDecimal getNetCashFlow() {
//		return netCashFlow;
//	}
//	
//	public void setNetCashFlow(BigDecimal netCashFlow) {
//		this.netCashFlow = netCashFlow;
//	}
//	
//	public BigDecimal getReturnOnEquity() {
//		return returnOnEquity;
//	}
//	
//	public void setReturnOnEquity(BigDecimal returnOnEquity) {
//		this.returnOnEquity = returnOnEquity;
//	}
//	
//	public BigDecimal getReturnOnTotalAsset() {
//		return returnOnTotalAsset;
//	}
//	
//	public void setReturnOnTotalAsset(BigDecimal returnOnTotalAsset) {
//		this.returnOnTotalAsset = returnOnTotalAsset;
//	}
	
	public BigDecimal getQuickRatio() {
		return quickRatio;
	}
	
	public void setQuickRatio(BigDecimal quickRatio) {
		this.quickRatio = quickRatio;
	}
	
	public BigDecimal getTotalliabilities() {
		return totalliabilities;
	}
	
	public void setTotalliabilities(BigDecimal totalliabilities) {
		this.totalliabilities = totalliabilities;
	}
	
//	public BalanceSheet getBalanceSheet() {
//		return balanceSheet;
//	}
//	
//	public void setBalanceSheet(BalanceSheet balanceSheet) {
//		this.balanceSheet = balanceSheet;
//	}
//	
//	public ProfitlossSheet getProfitlossSheet() {
//		return profitlossSheet;
//	}
//	
//	public void setProfitlossSheet(ProfitlossSheet profitlossSheet) {
//		this.profitlossSheet = profitlossSheet;
//	}
//	
//	public CashSheet getCashSheet() {
//		return cashSheet;
//	}
//	
//	public void setCashSheet(CashSheet cashSheet) {
//		this.cashSheet = cashSheet;
//	}
	
//	public BigDecimal getRegisteredCapital() {
//		return registeredCapital;
//	}
//	
//	public void setRegisteredCapital(BigDecimal registeredCapital) {
//		this.registeredCapital = registeredCapital;
//	}
	
	public BigDecimal getTotalcost() {
		return totalcost;
	}
	
	public void setTotalcost(BigDecimal totalcost) {
		this.totalcost = totalcost;
	}
	
	public BigDecimal getQuickassets() {
		return quickassets;
	}
	
	public void setQuickassets(BigDecimal quickassets) {
		this.quickassets = quickassets;
	}
	
	public BigDecimal getMainIncomeProfits() {
		return mainIncomeProfits;
	}
	
	public void setMainIncomeProfits(BigDecimal mainIncomeProfits) {
		this.mainIncomeProfits = mainIncomeProfits;
	}

	public BigDecimal getPrimeOperatingRevenue() {
		return primeOperatingRevenue;
	}

	public void setPrimeOperatingRevenue(BigDecimal primeOperatingRevenue) {
		this.primeOperatingRevenue = primeOperatingRevenue;
	}

	public BigDecimal getProfitLossProfit() {
		return profitLossProfit;
	}

	public void setProfitLossProfit(BigDecimal profitLossProfit) {
		this.profitLossProfit = profitLossProfit;
	}

	public BigDecimal getProfitRatio() {
		return profitRatio;
	}

	public void setProfitRatio(BigDecimal profitRatio) {
		this.profitRatio = profitRatio;
	}
	
}