package com.gx.obe.struct.beans;

import java.util.List;

import com.gx.obe.http.json.JsonUtil;

/**
 * 评审指标结构化区域
 * @author gnauh
 *
 */
public class IntelligentEvalDO {
	
	/**
	 * @Description: 供应商问题描述
	 */
//	private String supplierQuestion;
	/**
	 * @Description: 是否需要上传附件 00不需要 01 需要
	 */
//	private String isMustBoundFile;
	/**
	 * @Description: 指标来源 供应商响应：A ，系统采集：B ，供应商响应时：指标内容只能是99无，指标模型可不考虑；系统采集时：指标内容不能是99无，指标模型必选；
	 */
//	private String factorSource;
	/**
	 * @Description: 指标内容 01 注册资金、02 履约异常、03同业业绩、04 全部业绩、05 合格率、06 供应商等级、07使用质量、08 交付履约绩效、99 其它类型
	 */
	private String factorType;
	/**
	 * @Description: 区间模型 05 时间模型06 升降率模型 07 否决项模型 08
	 */
	private String factorModel;
	/**
	 * @Description: 评审指标代码 指标模型+指标来源+指标内容+四位流水码
	 */
	private String factorCode;
	/**
	 * @Description: 开始日期
	 */
//	private String startDate;
	/**
	 * @Description: 结束日期
	 */
//	private String endDate;
	/**
	 * @Description: 单位 万元01，个02
	 */
//	private String unit;
	/**
	 * @Description: 单位 万元01，个02
	 */
//	private String unitCode;
//	/**
//	 * @Description: 类型说明是否项：是 01，否 00
//	 */
//	private String correctResult;
	/**
	 * @Description: 评审模型描述
	 */
//	private String intelligentEvalRemark;
	/**
	 * @Description: 区间列表
	 */
	private List<ConditionDO> conditionList;
//	/**
//	 * @Description: 时间模型
//	 */
//	private TimeModelDO timeModel;
	/**
	 * @Description: 升降率模型
	 */
	private LiftRateDO liftRate;
	
	private List<ScoreOptionsDO> scoreOptionsDOList;
//	/**
//	 * @Description: 否决项模型
//	 */
//	private VoteModelDO voteModel;
//	/**
//	 * @Description: 自定义模型
//	 */
//	private List<CustomModelDo> customModelList;
	
	public String toJson() {
		return JsonUtil.jsonObjectToStr(this);
	}
	
//	public String getSupplierQuestion() {
//		return supplierQuestion;
//	}
//	
//	public void setSupplierQuestion(String supplierQuestion) {
//		this.supplierQuestion = supplierQuestion;
//	}
	
//	public String getIsMustBoundFile() {
//		return isMustBoundFile;
//	}
//	
//	public void setIsMustBoundFile(String isMustBoundFile) {
//		this.isMustBoundFile = isMustBoundFile;
//	}
	
//	public String getFactorSource() {
//		return factorSource;
//	}
//	
//	public void setFactorSource(String factorSource) {
//		this.factorSource = factorSource;
//	}
	
	private AbsoluteModelDO absoluteModelDO;
	
	public AbsoluteModelDO getAbsoluteModelDO() {
		return absoluteModelDO;
	}

	public void setAbsoluteModelDO(AbsoluteModelDO absoluteModelDO) {
		this.absoluteModelDO = absoluteModelDO;
	}

	public String getFactorType() {
		return factorType;
	}
	
	public void setFactorType(String factorType) {
		this.factorType = factorType;
	}
	
	public String getFactorModel() {
		return factorModel;
	}
	
	public void setFactorModel(String factorModel) {
		this.factorModel = factorModel;
	}
	
	public String getFactorCode() {
		return factorCode;
	}
	
	public void setFactorCode(String factorCode) {
		this.factorCode = factorCode;
	}
	
//	public String getStartDate() {
//		return startDate;
//	}
//	
//	public void setStartDate(String startDate) {
//		this.startDate = startDate;
//	}
	
//	public String getEndDate() {
//		return endDate;
//	}
//	
//	public void setEndDate(String endDate) {
//		this.endDate = endDate;
//	}
//	
//	public String getUnit() {
//		return unit;
//	}
//	
//	public void setUnit(String unit) {
//		this.unit = unit;
//	}
//	
//	public String getUnitCode() {
//		return unitCode;
//	}
//	
//	public void setUnitCode(String unitCode) {
//		this.unitCode = unitCode;
//	}
	
	public List<ConditionDO> getConditionList() {
		return conditionList;
	}
	
	public void setConditionList(List<ConditionDO> conditionList) {
		this.conditionList = conditionList;
	}
	

	public List<ScoreOptionsDO> getScoreOptionsDOList() {
		return scoreOptionsDOList;
	}

	public void setScoreOptionsDOList(List<ScoreOptionsDO> scoreOptionsDOList) {
		this.scoreOptionsDOList = scoreOptionsDOList;
	}

	//	public TimeModelDO getTimeModel() {
//		return timeModel;
//	}
//	
//	public void setTimeModel(TimeModelDO timeModel) {
//		this.timeModel = timeModel;
//	}
//	
	public LiftRateDO getLiftRate() {
		return liftRate;
	}
	
	public void setLiftRate(LiftRateDO liftRate) {
		this.liftRate = liftRate;
	}
	
//	public VoteModelDO getVoteModel() {
//		return voteModel;
//	}
//	
//	public void setVoteModel(VoteModelDO voteModel) {
//		this.voteModel = voteModel;
//	}
	
//	public String getCorrectResult() {
//		return correctResult;
//	}
//	
//	public void setCorrectResult(String correctResult) {
//		this.correctResult = correctResult;
//	}
	
//	public String getIntelligentEvalRemark() {
//		return intelligentEvalRemark;
//	}
//	
//	public void setIntelligentEvalRemark(String intelligentEvalRemark) {
//		this.intelligentEvalRemark = intelligentEvalRemark;
//	}
//	
//	public List<CustomModelDo> getCustomModelList() {
//		return customModelList;
//	}
//	
//	public void setCustomModelList(List<CustomModelDo> customModelList) {
//		this.customModelList = customModelList;
//	}
	
}
