package com.gx.obe.struct.composite;

import java.io.File;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.bind.prop.Prop;
import com.gx.obe.common.file.widget.FileButton;
import com.gx.obe.component.rx.RxSwt;
import com.gx.obe.component.utils.CompositeUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.struct.beans.AttachmentFile;
import com.gx.obe.struct.service.AttachmentFileService;

public class AttachmentComposite extends Composite {
	
	private final AttachmentFileService attachmentFileService = new AttachmentFileService();
	
	private final Prop<List<AttachmentFile>> attachmentFileList = new Prop<>();
	
	private final String tenderId;
	
	private String bidFilePath;
	
	public AttachmentComposite(Composite parent, String tenderId) {
		super(parent, SWT.NONE);
		this.tenderId = tenderId;
		
		RowLayout rowLayout = new RowLayout(SWT.HORIZONTAL);
		rowLayout.marginRight = 5;
		rowLayout.marginLeft = 5;
		rowLayout.marginBottom = 5;
		rowLayout.marginTop = 5;
		rowLayout.spacing = 5;
		setLayout(rowLayout);
		
		attachmentFileList.bind(l -> {
			CompositeUtils.disposeChildren(this);
			l.forEach(t -> new FileButton(this, new File(bidFilePath + t.getFileUrl()), t.getFileName()));
			this.layout();
		});
		
	}
	
	public void refresh(String supplierId, String businessId) {
		bidFilePath = Constants.getBidFilePath(tenderId, supplierId);
		RxSwt.run(() -> attachmentFileService.getAttachmentFileList(businessId)).checkWidget(this).exe(attachmentFileList::set);
	}
	
	@Override
	protected void checkSubclass() {}
	
}
