package com.gx.obe.struct.dialog;

import java.text.MessageFormat;
import java.util.Optional;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.bind.prop.Prop;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.ImageRaido;
import com.gx.obe.component.handler.RaidoHandler;
import com.gx.obe.component.rx.RxSwt;
import com.gx.obe.components.core.enumeration.EvaluationStepEnum;
import com.gx.obe.step.dialog.EvaluationStepDialog;
import com.gx.obe.struct.enums.EvaluationFactorTypeEnum;
import com.gx.obe.util.utils.CollectionUtils;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.expert.ExpertService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class FactorClearBidStepDialog extends EvaluationStepDialog {
	
	private final ExpertService expertService = new ExpertService();
	
	private final Prop<EvaluationFactorTypeEnum> evaluationFactorTypeEnum = new Prop<>();
	
	private final Prop<Expert> expert = new Prop<>();
	
	public FactorClearBidStepDialog(Shell parentShell, TenderProjectEntity tenderProject, EvaluationStep evaluationStep) {
		super(parentShell, tenderProject, evaluationStep);
	}
	
	@Override
	protected void createFromArea(Composite fromComposite, Composite gridComposite) {
		evaluationFactorTypeEnum.bind(t -> {
			switch (t) {
				case COMPLIANCE:
					setStepNameText("符合性指标评议");
					break;
				case BUSINESS:
					setStepNameText("商务指标评议");
					break;
				case TECHNOLOGY:
					setStepNameText("技术指标评议");
					break;
			}
		});
		evaluationFactorTypeEnum.bind(t -> expert.set(null));
		
		CLabel label = new CLabel(fromComposite, SWT.NONE);
		label.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		label.setAlignment(SWT.RIGHT);
		label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label.setText("评议类型：");
		
		Composite composite = new Composite(fromComposite, SWT.NONE);
		composite.setLayout(new GridLayout(2, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		Composite composite_1 = new Composite(composite, SWT.NONE);
		composite_1.setLayout(new GridLayout(3, false));
//		RaidoHandler<ImageRaido, EvaluationFactorTypeEnum> raidoHandler = new RaidoHandler<ImageRaido, EvaluationFactorTypeEnum>(composite_1, p->{
//			
//		});
//		RaidoHandler<ImageRaido, EvaluationFactorTypeEnum> raidoHandler = new RaidoHandler<>(composite_1, p -> {
//			ImageRaido imageRaido = new ImageRaido(p, SWT.NONE);
//			imageRaido.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
//			imageRaido.setImageSize(24);
//			return imageRaido;
//		});
//		raidoHandler.start().hand(EvaluationFactorTypeEnum.COMPLIANCE, "符合性评议").hand(EvaluationFactorTypeEnum.BUSINESS, "商务评议").hand(EvaluationFactorTypeEnum.TECHNOLOGY, "技术评议").end();
//		evaluationFactorTypeEnum.bindBidirectional(raidoHandler);
		
		Composite composite_2 = new Composite(composite, SWT.NONE);
		GridLayout gl_composite_2 = new GridLayout(2, false);
		composite_2.setLayout(gl_composite_2);
		evaluationFactorTypeEnum.bindExe(t -> {
			WidgetUtils.setControlVisible(composite_2, t != null);
			composite_2.getParent().layout();
		});
		
		Composite composite_3 = new Composite(composite_2, SWT.NONE);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.verticalSpacing = 0;
		gl_composite_3.marginHeight = 0;
		gl_composite_3.marginWidth = 0;
		composite_3.setLayout(gl_composite_3);
		
		CLabel lblNewLabel = new CLabel(composite_3, SWT.NONE);
		lblNewLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		expert.bind(t -> {
			lblNewLabel.setText(Optional.ofNullable(t).map(Expert::getUserName).orElse(""));
			lblNewLabel.getParent().layout();
		});
		
		ESepator label_1 = new ESepator(composite_3, SWT.HORIZONTAL);
		GridData gd_label_1 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_label_1.widthHint = 100;
		label_1.setLayoutData(gd_label_1);
		label_1.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		ELink select_expert = new ELink(composite_2, SWT.NONE);
		select_expert.addMouseListener(MouseListener.mouseUpAdapter($ -> selectExpert()));
		select_expert.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/search.png"));
		select_expert.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, true, 1, 1));
		select_expert.setText(MessageFormat.format("选择{0}", "验证专家"));
	}
	
	private void selectExpert() {
		SelectStepExpertDialog.selectExpert(getShell(), tenderProject.getId(), evaluationFactorTypeEnum.get()).thenThrow(expert::set);
	}
	
	@Override
	protected void setFromData(EvaluationStep evaluationStep) {
		evaluationFactorTypeEnum.set(EvaluationFactorTypeEnum.MAP.get(evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.EVALUATION_FACTOR_TYPE)));
		RxSwt.run(() -> expertService.getEvaluationStepExpertList(tenderProject.getId(), evaluationStep)).checkWidget(getShell()).exe(t -> {
			if (CollectionUtils.isNotNull(t)) expert.set(t.get(0));
		});
	}
//	
//	@Override
//	protected String valFromData() {
//		if (evaluationFactorTypeEnum.get() == null) return "请选择评审类型！";
//		if (expert.get() == null) return "请选择评审专家！";
////		return super.valFromData();
//	}
	
	@Override
	protected void getFromData(EvaluationStep evaluationStep) {
		evaluationStep.setEvaluationParam(EvaluationStepEnum.EVALUATION_FACTOR_TYPE, evaluationFactorTypeEnum.get().getKey());
		evaluationStep.setRoleType(EvaluationStepEnum.CUSTOM);
		addStepExpertUserId(expert.get().getUserId());
	}
	
	@Override
	protected String getTipsText() {
		return "评审专家通过对供应商标书及结构化数据进行分析后对每一下评审指标录入评审意见！";
	}
	
	@Override
	protected String getStepNameDef() {
		return "指标评议";
	}
	
	@Override
	protected String getStepType() {
		return EvaluationStepEnum.FACTOR_CLEAR_BID;
	}
	
	@Override
	protected Point getInitialSize() {
		return new Point(600, 400);
	}

	@Override
	protected String valFromData() {
		// TODO Auto-generated method stub
		return null;
	}
	
}
