package com.gx.obe.struct.handler;

import java.util.List;

import com.gx.obe.business.entity.SupplierEvaluationFactor;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.struct.inters.IFactorClearBidContent;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.evaluation.EvaluationFactor;
import com.gx.obe.web.service.SupplierEvaluationFactorService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.evaluation.EvaluationFactorService;

public class FactorClearBidContentFactory {
	
	private SupplierService supplierService = new SupplierService();
	private EvaluationFactorService evaluationFactorService = new EvaluationFactorService();
	private SupplierEvaluationFactorService supplierEvaluationFactorService = new SupplierEvaluationFactorService();
	
	private String tenderId;
	private List<Supplier> supplierList;
	private List<SupplierEvaluationFactor> supplierEvaluationFactorList;
	
	public FactorClearBidContentFactory(String tenderId) {
		this.tenderId = tenderId;
		this.supplierList = supplierService.getOpenBidSuccessSupplier(tenderId);
		this.supplierEvaluationFactorList = supplierEvaluationFactorService.getEntityListByTenderId(tenderId);
	}
	
	public IFactorClearBidContent create(String audit) {
		List<EvaluationFactor> factorList = evaluationFactorService.getAllEvaluationFactorList(tenderId, audit);
		return new IFactorClearBidContent() {
			
			@Override
			public String getTableName() {
				if (EvaluationFactorEnum.AUDIT_COMPLIANCE.equals(audit)) {
					return "符合性指标清标表";
				}
				if (EvaluationFactorEnum.AUDIT_SCORE.equals(audit)) {
					return "打分指标清标表";
				}
				return null;
			}
			
			public String getFileName() {
				if (EvaluationFactorEnum.AUDIT_COMPLIANCE.equals(audit)) {
					return "指标清标意见-符合性.xlsx";
				}
				if (EvaluationFactorEnum.AUDIT_SCORE.equals(audit)) {
					return "指标清标意见-打分.xlsx";
				}
				return null;
			}
			
			public List<Supplier> getSupplierList() {
				return supplierList;
			}
			
			public List<EvaluationFactor> getFactorList() {
				return factorList;
			}
			
			public List<SupplierEvaluationFactor> getSupplierEvaluationFactorList() {
				return supplierEvaluationFactorList;
			}

			public String getContent(SupplierEvaluationFactor supplierEvaluationFactor) {
				return supplierEvaluationFactor.getFactorResponse();
			}
		};
	}
	
}
