package com.gx.obe.struct.handler;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.function.Consumer;

import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.common.file.utils.FileUtils;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.components.core.global.Global;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;

public class FactorClearBidFileHandler {
	
	private Shell parentShell;
	private TenderProjectEntity tenderProject;
	
	public FactorClearBidFileHandler(Shell parentShell, TenderProjectEntity tenderProject) {
		this.parentShell = parentShell;
		this.tenderProject = tenderProject;
	}
	
	public void export() {
		String directorySavePath = FileDialogUtils.getDirectorySavePath("请选择导出目录", "[" + tenderProject.getTenderNo() + "]" + tenderProject.getTenderName());
		if (StringUtils.isEmpty(directorySavePath)) {
			return;
		}
		
		String saveDir = directorySavePath + "[" + FileUtils.filterFileName(tenderProject.getTenderNo()) + "]" + "指标清标文件";
		
		ProgressMessageDialog messageDialog = new ProgressMessageDialog(parentShell, false, -1, null);
		messageDialog.setTitle("导出指标清标文件");
		
		BiConsumer<String, Integer> message = (msg, flag) -> Display.getDefault().syncExec(() -> messageDialog.message(msg, flag));
		Consumer<Boolean> finish = t -> Display.getDefault().syncExec(() -> messageDialog.finish(t));
		
		new Thread(() -> {
			message.accept("开始导出指标清标文件！", 0);
			
			try {
				Map<String, Object> scoreDateMap = new HashMap<>();
				scoreDateMap.put("factorClearBidContent", new FactorClearBidContentFactory(tenderProject.getId()).create(EvaluationFactorEnum.AUDIT_SCORE));
				Global.EXCEL_REPORT.generate(tenderProject, "FactorClearBidContent.xlsx", saveDir, scoreDateMap).waitOrGet();
			} catch (Exception e1) {
				message.accept("打分清标意见表生成失败！", -1);
			}
//			try {
//				Global.EXCEL_REPORT.generate(tenderProject, "ProjectManagerPerformanceDataSet.xlsx", saveDir, null).waitOrGet();
//			} catch (Exception e1) {
//				message.accept("项目经理业绩表生成失败！", -1);
//			}
//			try {
//				Global.EXCEL_REPORT.generate(tenderProject, "EnterprisePerformanceDataSet.xlsx", saveDir, null).waitOrGet();
//			} catch (Exception e1) {
//				message.accept("企业业绩表生成失败！", -1);
//			}
			
			message.accept("完成导出指标清标文件！", 0);
			
			if (messageDialog.getErrorMessagesSize() != 0) {
				finish.accept(false);
				return;
			}
			
			finish.accept(true);
			Display.getDefault().syncExec(() -> {
				if (MessageDialog.openConfirm(parentShell, "打开目录", "导出成功，是否打开目录！", new String[] { "打开", "关闭" })) {
					System.out.println(saveDir);
					RuntimeUtils.openDirector(saveDir);
				}
			});
		}).start();
		messageDialog.open();
	}
	
}
