package com.gx.obe.struct.utils;

import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

import org.apache.commons.dbutils.BeanProcessor;
import org.apache.log4j.Logger;

import com.gx.obe.util.utils.BeanUtils;

/**
 * @Description: 
 * @author guoyr
 */
public class Bean2MapUtils extends BeanProcessor{
	
	private static Logger LOG = Logger.getLogger(Bean2MapUtils.class);
	
	/**
	 * @Description: 将bean转为Map 
	 * @author guoyr
	 * @param <K>
	 * @param <V>
	 * @param bean
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public static <K, V, T> Map<K, V> createMap(T bean){
			
		if(null == bean){
			return null;
		}
		Class<? extends Object> clazz = bean.getClass();
		Map<K, V> beanMap = new HashMap<K, V>();
		for(java.lang.reflect.Field field : bean.getClass().getDeclaredFields()){
			
			String property = field.getName();
//			if(property.equals("calculationParam")){
//				System.out.println(property);
//			}
			Method getMethod = getClassMethod(clazz, new StringBuilder("get").append(property.substring(0,1).toUpperCase()).append(property.substring(1)).toString(), null);
			if(null == getMethod){
				if(field.getType() == boolean.class || field.getType() == Boolean.class ){
					if(property.startsWith("is")){
						getMethod = getClassMethod(clazz, property, null);
					}else {
						getMethod = getClassMethod(clazz, new StringBuilder("is").append(property.substring(0,1).toUpperCase()).append(property.substring(1)).toString(), null);
					}
				}
			}
			if(null != getMethod){
				Object obj = null;
				try {
					obj = getMethod.invoke(bean);
				} catch (IllegalArgumentException e) {
					LOG.error("获得"+field.getName()+"值时出错", e);
				} catch (IllegalAccessException e) {
					LOG.error("获得"+field.getName()+"值时出错", e);
				} catch (InvocationTargetException e) {
					LOG.error("获得"+field.getName()+"值时出错", e);
				}
				if(null != obj){
					if(BeanUtils.isNativeType(field.getType())){
						beanMap.put((K)field.getName(), (V) obj);
//					}else if(obj instanceof Map || obj instanceof Set || obj instanceof List){
//						beanMap.put((K)field.getName(), (V) obj);
					}else if(field.getType() instanceof Serializable){
						beanMap.put((K)field.getName(), (V)createMap(obj));
					}else {
						beanMap.put((K)field.getName(), (V) obj);
					}
				}
			}
		}
		return beanMap;
	} 
	
	private static java.lang.reflect.Method getClassMethod(Class<?> type, String property, Class<?> propType){
		Method setMethod = null;
		try {
			setMethod = type.getMethod(property);
		} catch (SecurityException e) {
		} catch (NoSuchMethodException e) {
		}
		return setMethod;
		
	}
}
