package com.gx.obe.struct.widget;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.bind.prop.Prop;
import com.gx.obe.bind.recursion.Recursions;
import com.gx.obe.component.handler.ISelection;
import com.swtdesigner.SWTResourceManager;

public class TabButton extends Composite implements ISelection {
	
	private Prop<Boolean> selection = new Prop<>(false);
	
	private Prop<String> text = new Prop<>();
	
	public TabButton(Composite parent) {
		super(parent, SWT.NONE);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginTop = 5;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		Composite composite = new Composite(this, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.marginWidth = 30;
		gl_composite.marginHeight = 0;
		composite.setLayout(gl_composite);
		
		Label lblNewLabel = new Label(composite, SWT.NONE);
		lblNewLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		lblNewLabel.setFont(SWTResourceManager.getFont("Microsoft YaHei UI", 10, SWT.BOLD));
		text.bind(lblNewLabel::setText);
		selection.bindExe(t -> lblNewLabel.setForeground(t ? SWTResourceManager.getColor(2, 71, 191) : SWTResourceManager.getColor(0, 0, 0)));
		
		Label label = new Label(this, SWT.NONE);
		GridData gd_label = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_label.heightHint = 2;
		label.setLayoutData(gd_label);
		selection.bindExe(t -> label.setBackground(t ? SWTResourceManager.getColor(2, 71, 191) : SWTResourceManager.getColor(SWT.COLOR_WHITE)));
	}
	
	@Override
	public void setText(String text) {
		this.text.set(text);
	}
	
	@Override
	public void setSelection(boolean selection) {
		this.selection.set(selection);
	}
	
	@Override
	public void addMouseListener(MouseListener mouseListener) {
		Recursions.array((Control c) -> c instanceof Composite ? ((Composite) c).getChildren() : null).toStream(this.getChildren()).forEach(c -> c.addMouseListener(mouseListener));
	}
	
	@Override
	protected void checkSubclass() {}

}
